unit Lists;
  { Oktober 2003; Tom Verhoeff; versie 1.0 }
  { unit om lijsten te manipuleren }
  { Oefenversie zonder implementatie van Find }

interface

const
  MaxListLen = 24; { maximum lengte van een lijst, 1 <= MaxListLen }
  MinEntry = 0; { kleinste waarde in een lijst }
  MaxEntry = 99; { grootste waarde in een lijst, MinEntry <= MaxEntry }
  
type
  TIndex = 0 .. MaxListLen - 1; { index in een lijst }
  TEntry = MinEntry .. MaxEntry; { waarde in een lijst }
  TList = record
            len: 0 .. MaxListLen; { actuele lengte van de lijst }
            val: array [ TIndex ] of TEntry; { de rij van waarden in de lijst }
          end;
  { Voor s: TList, is vereist dat s.val[i] gedefinieerd is voor 0 <= i < s.len }
  
procedure Find ( const s: TList; const x: TEntry;
                 out found: Boolean; out pos: TIndex );
  { zoek x in lijst s }
  { pre:  s is oplopend gesorteerd (duplicaten toegestaan)
    post: found = `er bestaat een i met 0<=i<s.len en s.val[i]=x', en
          found impliceert  0<=pos<s.len  en  s.val[pos] = x }

procedure WriteList ( var f: Text; const ident: String; const s: TList );
  { schrijf lijst s naar f }
  { pre:  f is geopend om te schrijven
    post: lijst s is geschreven naar f, volgens het formaat
          ident.len: ...
          ident.val: ... }

procedure GenerateList ( out s: TList; const n, m, d, c: Integer );
  { genereer lijst s met lengte n volgens patroon m, d, c:
    blokken van lengte d met gelijke waarden c, c+m, c+2m, ... }
  { pre:  0 <= n <= MaxListLen,  0 < d,
          MinEntry <= m * (i div d) + c <= MaxEntry  voor 0 <= i < n
    post: s.len = n  en  s.val[i] = m * (i div d) + c  voor 0 <= i < n }

implementation

procedure Find ( const s: TList; const x: TEntry;
                 out found: Boolean; out pos: TIndex );
  { zie interface }
  { lokale variabelen }
  begin
    Commentaar met naam, identiteitsnummer, datum
    Eigen implementatie van Binary Search
  end; { Find }

procedure WriteList ( var f: Text; const ident: String; const s: TList );
  { zie interface }
  var
    i: Integer; { om waarden van s te doorlopen }
     { i: TIndex, but then for-loop fails with Range Check error when s.len=0 }
  begin
    with s do begin
      writeln ( f, ident, '.len: ', len )
    ; write ( f, ident, '.val:' )

    ; for i := 0 to len - 1 do begin
        write ( f, ' ', val [ i ] )
      end { for i }

    ; writeln ( f )
    end { with s }
  end; { WriteList }

procedure GenerateList ( out s: TList; const n, m, d, c: Integer );
  { zie interface }
  begin
    with s do begin
      len := 0

      { invariant: val[i] ingevuld voor alle i met 0 <= i < len <= n }
    ; while len <> n do begin
        val[len] := m * ( len div d ) + c
      ; len := len + 1
      end { for len }

    end { with s }
  end; { GenerateList }

end.
